export const serialize = <T>(
  data: T,
): string => {
  if (typeof data !== 'object') {
    throw new TypeError('Data must be an object');
  }
  return new URLSearchParams(data as Record<string, string>).toString();
}

export const deserialize = <T>(
  serialized: string,
): T => {
  return Object.fromEntries(
    new URLSearchParams(serialized).entries()
  ) as unknown as T;
}
